/* 
 * Here is where system computed values get stored.
 * These values should only change when the target compile platform changes.
 */

#if defined(WIN32) && !defined(VTKSLICER_STATIC)
#pragma warning ( disable : 4275 )
#endif

#define CMAKE_WORDS_BIGENDIAN
#ifdef CMAKE_WORDS_BIGENDIAN
  #define WORDS_BIGENDIAN
#else
  #define WORDS_LITTLEENDIAN
#endif

#define BUILD_SHARED_LIBS
#ifndef BUILD_SHARED_LIBS
#define VTKSLICER_STATIC
#endif

/* #undef Slicer3_USE_BatchMake */
/* #undef Slicer3_USE_IGSTK */
#define Slicer3_USE_MIDAS
/* #undef Slicer3_USE_NAVITRACK */
/* #undef Slicer3_USE_NUMPY */
#define Slicer3_USE_PYTHON
/* #undef Slicer3_USE_PYTHONQT */
/* #undef Slicer3_USE_OPENTRACKER */
/* #undef Slicer3_USE_QT */
#define Slicer3_USE_KWWIDGETS
/* #undef Slicer3_USE_VTK_CVSHEAD */

#define VTKSLICER_CONFIGURATION_TYPES ""

#define Slicer3_INSTALL_BIN_DIR "bin"
#define Slicer3_INSTALL_LIB_DIR "lib/Slicer3"
#define Slicer3_INSTALL_INCLUDE_DIR "include/Slicer3"
#define Slicer3_INSTALL_SHARE_DIR "share/Slicer3"
#define Slicer3_INSTALL_ITKFACTORIES_DIR "lib/Slicer3/ITKFactories"

#define Slicer3_INSTALL_PLUGINS_BIN_DIR "lib/Slicer3/Plugins"
#define Slicer3_INSTALL_PLUGINS_LIB_DIR "lib/Slicer3/Plugins"
#define Slicer3_INSTALL_PLUGINS_INCLUDE_DIR "include/Slicer3/Plugins"
#define Slicer3_INSTALL_PLUGINS_SHARE_DIR "share/Slicer3/Plugins"
#define Slicer3_INSTALL_PLUGINS_CACHE_DIR "lib/Slicer3/PluginsCache"

#define Slicer3_INSTALL_MODULES_BIN_DIR "lib/Slicer3/Modules"
#define Slicer3_INSTALL_MODULES_LIB_DIR "lib/Slicer3/Modules"
#define Slicer3_INSTALL_MODULES_INCLUDE_DIR "include/Slicer3/Modules"
#define Slicer3_INSTALL_MODULES_SHARE_DIR "share/Slicer3/Modules"

#ifdef Slicer3_BUILD_QTLOADABLEMODULES
#  define Slicer3_INSTALL_QTLOADABLEMODULES_BIN_DIR ""
#  define Slicer3_INSTALL_QTLOADABLEMODULES_LIB_DIR ""
#  define Slicer3_INSTALL_QTLOADABLEMODULES_INCLUDE_DIR ""
#  define Slicer3_INSTALL_QTLOADABLEMODULES_SHARE_DIR ""
#endif //Slicer3_BUILD_QTLOADABLEMODULES

/* Do not use those variables unless you can not retrieve the Tcl/Tk version
   at run-time using this code below:
   int tcl_major, tcl_minor, tcl_patch_level;
   Tcl_GetVersion(&tcl_major, &tcl_minor, &tcl_patch_level, NULL);
*/
#define Slicer3_TCL_TK_MAJOR_VERSION "8"
#define Slicer3_TCL_TK_MINOR_VERSION "5"
#define Slicer3_INCR_TCL_MAJOR_VERSION ""
#define Slicer3_INCR_TCL_MINOR_VERSION ""

// Convenient macro to print info provided as argument
// Note: No-op is Slicer3_USE_QT OFF
#ifdef Slicer3_USE_QT
#define SlicerQDebug(_arg) {qDebug() << _arg;}
#else
#define SlicerQDebug(_arg)
#endif

// Library sub-directory
#define VTK_DIR "/usr/lib/vtk-5.6"
//#define Teem_DIR "/usr/lib/Teem-1.10.0"
